/*	$Id: qcpp.h,v 1.3 2009/07/18 11:49:17 nis Exp $	*/

/*-
 * Copyright (c) 2005 Shingo Nishioka.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#define CElem			1
#define CString			2
#define CComment		3
#define CPi			4

#define CUnquote		5
#define CUnquoteSplicing	6
#define CQquote			7
#define CCtoken			8

#define AAttribute		1
#define	AUnquote		2
#define	AUnquoteVal		3
#define	AUnquoteSplicing	4

struct attribute {
	int type;	/* AAtribute | AUnquote */
	char *name;
	union {
		char *string;
		struct cexpr *cexpr;
	} value;
};

struct element {
	int type;	/* CElem */
	char *name;
	struct attribute *attributes;
	union content **contents;
};

struct chardata {
	int type;	/* CString */
	/* size_t len; -- only in cxml.h */
	char *value;
};

struct misc {
	int type;	/* CComment | CPi */
	char *pitarget;	/* CPi */
	/* size_t len; -- only in cxml.h */
	char *string;	/* CComment | CPi */
};

struct cexpr {
	int type;
	union {
		char *token;
		struct element *qquote;
	} u;
	int line;
	struct cexpr *next;
};

union content {
	struct element element;
	struct chardata chardata;
/*
	struct reference reference;
*/
	struct misc misc;
	struct cexpr cexpr;
};

struct prolog {
	void *xmldecl;
	void *doctypedecl;
};

struct document {
	struct prolog *prolog;
	struct element *element;
};

struct cexpr *rqquote(FILE *);

void init_mygetc(FILE *);
int yytokline(void);
int yyline(void);
int yycolumn(void);
int yylastchar(void);
void yysetline(int);
int yylex(void);
